

#define  bool               unsigned char 

#define  d_Leg_RF           0
#define  d_Leg_RB           1
#define  d_Leg_LF           2
#define  d_Leg_LB           3

//Z ǥ ٸ ѱ̸  .
#define  d_LegLengthMax     129.659
 
#define                    3.14159265358979323846

//[2008.07.21.][߰!!!]
//{
    //  [߽]  ġ ȴ.
    //[]  ռ Ѵ. 
    #define  d_CM_Real_x    0.0          
    #define  d_CM_Real_y    0.0//-2.0          
    #define  d_CM_Real_z    0.0          
    
//}

//[]{-------------------------------------------------------------
// ϰ Ǵ ̹Ƿ ϸ  double  Ѵ.
//  mm  Ѵ.
//}-------------------------------------------------------------------

struct   LEG_RADIAN
{
  //[2007.12.30.][!!!]{---
  //  ´.
  //}---------------------------

  double   radAlpha;
  double   radBeta;
  double   radGamma;

};

struct   LEG_DEGREE
{
  //[2007.12.30.][!!!]{-----
  //0 - 180   ´.
  //}-----------------------------

  double   degAlpha;
  double   degBeta;
  double   degGamma;

};

struct   LEG_SPEED
{
  //[2008.01.01.ȭ][!!!]{-------
  //0 - 255  ӵ ´.
  //}-------------------------------

  double   speedAlpha;
  double   speedBeta;
  double   speedGamma;

};

struct   CORD_XYZ
{
  //[2007.12.30.][!!!]{---
  //ǥ (x, y, z)  .
  //}---------------------------

  double   x;
  double   y;
  double   z;

};

//[ȯ溯]
struct  LEG4_DESIGN_SPEC
{
  //[2007.12.30.][!!!]{--------------------
  //  ġ .
  //̴ ǥ 꿡   ȴ.
  //  mm  Ѵ.
  //}--------------------------------------------

  double   lt; //10.021 ( )
  double   lu; //60.638 ( )
  double   ld; //59     (Ƹ )

  //  ٸ  ġ.
  struct   CORD_XYZ  legOrg[4] ;
  //{
      //RF : (49.5, 70, 0)
      //RB : (49.5, -70, 0)
      //LF : (-49.5, 70, 0)
      //LB : (-49.5, -70, 0)

  //}

  //߽ġ.
  struct   CORD_XYZ  CM; //(0, -22, 0)


  //ڼ ȯ .
  double   swap;        //CM  ¿̵ϴ ũ. (⺻ : 15)
  double   step;        //1 ߰ ũ. (⺻ : 10)
  double   height;      //. (⺻ ü ٸ  129.659  ȴ.)
  double   foot_height; //ߵ .

  //[2008.01.01.ȭ][߰!!!]
  //⺻  ӵ̴.
  //0 - 255   ȿϴ.
  //   G.M.RC.BASiC  0  ְ ӵ̰ 255 ġ ӵ ̴.
  //׷Ƿ  ӵ  ÿ ݵ (255 - ӵ)  ؾ Ѵ.
  double   speed; //⺻ ӵ 200 Ѵ.(  밪 55  ȴ.)

};

//[2011.01.24.][Ϸ!!!]
void _4Leg_Var_Init(void);

void _4Leg_Var_loopOn(bool  pValue);

//[2008.07.21.][Ϸ!!!]
void _4Leg_CM_Set(double  pCMx,
                  double  pCMy,
                  double  pCMz);

void Init_4Leg_(void);

void Gyesan_Radian_withLegOrg(struct LEG_RADIAN   *rLegRadian,
                              double               pX,
                              double               pY,
                              double               pZ);

//[2007.12.30.][Ϸ!!!]
void Conv_RadianToServoRadian(struct LEG_RADIAN   *prServoRadian,
                              int                  pLegNumber);

void Conv_RadianToDegree(struct LEG_RADIAN   *pServoRadian,
                         struct LEG_DEGREE   *rServoDegree);

void Gyesan_ServoDegree_withLegOrg(struct LEG_DEGREE   *rLegDegree,
                                   int                  pLegNumber,
                                   double               pX,
                                   double               pY,
                                   double               pZ);

void Gyesan_ServoDegree(struct LEG_DEGREE   *rLegDegree,
                        int                  pLegNumber,
                        double               pX,
                        double               pY,
                        double               pZ);

void _4Leg_Cal_Degree4(void);

//[2011.02.15.ȭ][Ϸ!!!]
void _4Leg_Set_Degree4(unsigned char  pӵ,
                       //[2011.02.15.ȭ][߰!!!]
                       //[ ⵿]  Ͽ ʿ.
                       unsigned char  pӻ,
                       unsigned char  pϷẸ);


void _4Leg_xyz(double   pRFx, double   pRFy, double   pRFz,
               double   pRBx, double   pRBy, double   pRBz,
               double   pLFx, double   pLFy, double   pLFz,
               double   pLBx, double   pLBy, double   pLBz);
               
void _4Leg_xyz_RF(double   pRFx, double   pRFy, double   pRFz);
void _4Leg_xyz_RB(double   pRBx, double   pRBy, double   pRBz);
void _4Leg_xyz_LF(double   pLFx, double   pLFy, double   pLFz);
void _4Leg_xyz_LB(double   pLBx, double   pLBy, double   pLBz);

void _4Leg_xyz_Rotate(double    pRotateRadian,
                      double   *prX,
                      double   *prY);

//[2011.02.15.ȭ][Ϸ!!!]
void _4Leg_CalSet_DegSpd4(unsigned char  pӵ,
                          //[2011.02.15.ȭ][߰!!!]
                          //[ ⵿]  Ͽ ʿ.
                          unsigned char  pӻ,
                          unsigned char  pϷẸ);

//[2011.02.15.ȭ][Ϸ!!!]
void _4Leg_CalSet_DegSpd4_Leg(int            pٸ,
                              unsigned char  pӵ,
                              //[2011.02.15.ȭ][߰!!!]
                              //[ ⵿]  Ͽ ʿ.
                              unsigned char  pӻ,
                              unsigned char  pϷẸ);                             

void _4Leg_DegreeSave4(void);

//[2009.12.27.][Ϸ!!!]
void _4Leg_IsDone(void);



//[󱸵]
//{
    //[2011.03.17.][!!!]{-----------------------------
    // ˵   ϱ  [󱸵]  Ѵ.
    //}----------------------------------------------------
    
    //[2011.03.21.][߰!!!!]{---------------
    #define  ü___ũ    101
    //}---------------------------------------

    struct _ //101 Ʈ.
    {
      //[2011.03.17.][!!!]{---------------------------------------------------------------
      //[󱸵]      ִ    Ѵ.
      //̴  Ѱ شϴ .
      //
      //̴   ǥ ϴ  ð  ҿǾ ӵ  ˵ [ϷẸ]   
      // ۿ . , 꿡  ð  [ϷẸ] ð  ְ Ҽ ٴ ̴.
      //̸ Ͽ ̸ ش  Ͽ []    ,    []  ٷϿ
      //    óҼ ְ Ѵ.
      //}--------------------------------------------------------------------------------------

      //ٸ 4  12  Ѵ.
      struct LEG_DEGREE  ٸ[4]; //24*4 Ʈ.
  
      unsigned short     ӵ;       //2 Ʈ.
  
      unsigned char      ӵ;    //1 Ʈ.
      
      unsigned char      ӻ;  //1 Ʈ.
  
      unsigned char      ϷẸ; //1 Ʈ.

    };
    
    //[2011.03.17.][Ϸ!!!]
    void __4Leg_CalSet_DegSpd4(//  /Ͽ ȯѴ.
                                     struct _  *r,
                                     unsigned short            pӵ,
                                     unsigned char             pӵ,
                                     unsigned char             pӻ,
                                     unsigned char             pϷẸ);
    
    //[2011.03.17.][Ϸ!!!]
    void ___(struct _  *p);
    
    
    
    
    
    
//}



//[˵28ȣ ΰ Լ]
//{
    //[2010.07.20.ȭ][Ϸ!!!]
    void _GMTDLARC_RptTimeXWr(unsigned char  *pϷẸ);
    
    //[2010.07.20.ȭ][Ϸ!!!]
    void _GMTDLARC_AccelDivXWr(unsigned char  *pӻ);
    
//}

//[Լ]
//{
    //[]
    //{
        //[2011.04.22.][Ϸ!!!]
        void _4Leg_Go_Start_۹(void); //[󱸵Ϸ!!!]
        #define  d_4Leg_Go_Start_۹    0x0020110516002000
        
        //[2011.04.22.][Ϸ!!!]
        void _4Leg_Go_۹(void); //[󱸵Ϸ!!!]
        #define  d_4Leg_Go_۹    0x0020110516002000
        
        //[2011.04.22.][Ϸ!!!]
        void _4Leg_Go_Stop_۹(void); //[󱸵Ϸ!!!]
        #define  d_4Leg_Go_Stop_۹    0x0020110516002000

    //}

    //[]
    //{
        //[2011.02.21.][!!!]{------------------------------
        //   ü    .
        //  ݺ ӵ    .
        //}-----------------------------------------------------
    
        //[2011.04.22.][Ϸ!!!]
        void _4Leg_Back_Start_۹(void); //[󱸵Ϸ!!!]
        #define  d_4Leg_Back_Start_۹    0x0020110516002000
        
        //[2011.04.21.][Ϸ!!!]
        void _4Leg_Back_۹(void); //[󱸵Ϸ!!!]
        #define  d_4Leg_Back_۹    0x0020110516002000
        
        //[2011.04.22.][Ϸ!!!]
        void _4Leg_Back_Stop_۹(void); //[󱸵Ϸ!!!]
        #define  d_4Leg_Back_Stop_۹    0x0020110516002000

    //}
    
    //[]
    //{
        //[2011.04.23.][!!!]{-----------------------------------------------------------
        //[ ]  [ ]     ٸ  óϿ.
        //̴ HS-5645MG  ȸ⿡  Ī   ⿡  ȸӵ ̰ ֱ ̴.
        // ȸ ӵ ̷ ƿ ٸ   Ͽ.
        // ̰  پ  Ҽ  ȿ̴.
        //}----------------------------------------------------------------------------------
    
        //[ ]
        //{
            //[2011.04.23.][Ϸ!!!]
            void _4Leg_Go_Left_۹(void); //[󱸵Ϸ!!!]
            #define  d_4Leg_Go_Left_۹    0x0020110516002000

        //}

        //[ ]
        //{       
            //[2011.04.23.][Ϸ!!!]
            void _4Leg_Go_Right_۹(void); //[󱸵Ϸ!!!]
            #define  d_4Leg_Go_Right_۹    0x0020110516002000

        //}
        
    //}    

    //[ ȸ]
    //{
        //[2011.04.24.][Ϸ!!!]
        // ۸ ݾ ȸϴ   ٽ .
        void _4Leg_Turn_Left_۹(void); //[󱸵Ϸ!!!]
        #define  d_4Leg_Turn_Left_۹    0x0020110516002000

    //}

    //[ ȸ]
    //{
        //[2011.04.24.][Ϸ!!!]
        // ۸ ݾ ȸϴ   ٽ .
        void _4Leg_Turn_Right_۹(void); //[󱸵Ϸ!!!]
        #define  d_4Leg_Turn_Right_۹    0x0020110516002000

    //}
    

    //[  ]
    //{
        //[2010.08.02.ȭ][Ϸ!!!]
//        void _4Leg_Body_UpDown(bool   pPositionInit); 
        
        //[2010.07.28.][Ϸ!!!]
//        void _4Leg_Body_Go_Back(bool   pPositionInit); 
        
        //[2010.07.29.][Ϸ!!!]
//        void _4Leg_Body_SwapUpDown(bool   pPositionInit); 
     
        //[2010.08.10.ȭ][Ϸ!!!]
//        void _4Leg_Body_Circle_Left(bool   pPositionInit); 
        //[2010.08.10.ȭ][Ϸ!!!]
//        void _4Leg_Body_Circle_Right(bool   pPositionInit); 
     
        //[2010.09.26.][Ϸ!!!]
        void _4Leg_Stand(void); 

    //}

//}

//[ݽ + 4LEG ]
//{
    //[ ȣ ]
    //{
        #define  d__յ    12
        #define  d__¿    13
        #define  d__ȸ    14
        #define  d__Ȳġ     15
        #define  d__ոȸ    16
        #define  d__հ     17
        
        #define  d__յ     18
        #define  d__¿     19
        #define  d__ȸ     20
        #define  d__Ȳġ      21
        #define  d__ոȸ     22
        #define  d__հ      23
        
        #define  d_㸮_ȸ        24
        #define  d_㸮_յ        25
        #define  d_㸮_¿        26
        
    //}
    
    //[ΰԼ]
    //{
        //[2010.08.16.][ó!!!]
        void _ǥ㸮յ¿찢(double  pX, 
                                      double  pY,
                                      double  pȸ);
    
    //}
    
    //[]
    //{
        //[2010.08.14.][Ϸ!!!]
        void _4Leg_ü_(void);
    
        //[2010.08.14.][Ϸ!!!]
        void _4Leg_ٸ_(int  pٸ);

        //[2010.08.14.][Ϸ!!!]
        void _Body__(int     p,
                              double  p);
        
        //[2010.08.14.][Ϸ!!!]
        void _Body__(double  pյ,
                                double  p¿,
                                double  pȸ,
                                double  pȲġ,
                                double  pոȸ,
                                double  pհ);
        
        //[2010.08.14.][Ϸ!!!]
        void _Body__(double  pյ,
                              double  p¿,
                              double  pȸ,
                              double  pȲġ,
                              double  pոȸ,
                              double  pհ);
        
        //[2010.08.15.][Ϸ!!!]
        void _Body_㸮_(double  p㸮ȸ,
                              double  p㸮յ,
                              double  p㸮¿);
        
    //}
    
    //[˵28ȣ  ]
    //{
        //[2011.02.15.ȭ][Ϸ!!!]
        void _˵28ȣ_ȭ(unsigned char   pۼȣ,
                              unsigned char   pϰ,
                              //ְ(255) - (0).
                              unsigned short  pӵ,
                              unsigned char   pӵ,
                              //[2011.02.15.ȭ][߰!!!]
                              //[ ⵿]  Ͽ ʿ.
                              unsigned char   pӻ,
                              unsigned char   pϷẸ);
        
        //[2010.08.15.][Ϸ!!!]
        void _˵28ȣ_ӻ(unsigned char  pӻ);
    
    //}
    
    //[]
    //{
        //[2010.08.15.][Ϸ!!!]
        void _ιݸ_ݺ(bool  pݺ);
    
        //[⺻ ڼ ]
        //{
            //[2011.02.17.][Ϸ!!!]
            void _ιݸ_⺻ڼ(void);
        
            //[2011.02.17.][Ϸ!!!]
            void _Body_⺻ڼ(void); 
            
        //}
        
        //[  ]
        //{
            //[2011.02.17.][Ϸ!!!]
            void _ιݸ_(void); 

            //[2011.02.17.][Ϸ!!!]
            void _ιݸ_ȱġ(void); 
            
            //[2011.02.17.][Ϸ!!!]
            void _ιݸ_ۼ(void); 
            
            //[2011.02.17.][Ϸ!!!]
            void _ιݸ_ȼ(void); 
            
        //}
        
        //[ ]
        //{
            //[2011.02.15.ȭ][Ϸ!!!]
            void _ιݸ_㸮ݽð⵹(void); 
            
            //[2011.02.15.ȭ][Ϸ!!!]
            void _ιݸ_㸮ð⵹(void); 
            
            //[2011.02.17.][Ϸ!!!]
            void _ιݸ_¿ɱ⼭(void); 
            
            //[2011.02.17.][Ϸ!!!]
            void _ιݸ_ڸյ̵(void);
           
            //[2011.02.17.][Ϸ!!!]
            void _ιݸ_ڸ̵(void); // غ ݽ  Ѱ!
        
        //}
    
    //}

//}

//[24 ]
//{
    //[2011.02.21.][߰!!!]{-----
    // ο  õ .
    //}----------------------------
    
    //[2011.04.02.][Ϸ!!!]
    void __ڸ_۹(void); //[󱸵Ϸ!!!]
    #define  d__ڸ_۹    0x0020110516002000
    
    //[2011.04.21.][Ϸ!!!]
    void ____۹(void); //[󱸵Ϸ!!!]
    #define  d____۹    0x0020110516002000
    
    //[ϴܺ!!!]
    void __Ծζٱ_۹(void);
    
    
    //[2011.04.08.][Ϸ!!!]
    void ___۹(void); //[󱸵Ϸ!!!]
    #define  d___۹    0x0020110516002000
  
//}

//[324 ]
//{
    //[2011.04.25.][Ϸ!!!]
    void _324__۹(void); //[󱸵Ϸ!!!]
    #define  d_324__۹    0x0020110516002000
    
//}







